' BBE (2005) replicaton
' Figure 4

%path = @runpath
cd %path

mode quiet

' open the BBE data that is transformed to induce stationarity 
wfopen(type=txt) nsbalpanel.txt delim=space 
pagestruct(freq=m,start=1959)

'rename some variables   

for !i=1 to 9
	rename series0{!i} series{!i}
next

'do not standardize data. The package will standardize for you.

'Y variables  
genr ffr=series77

'All variables (X) except Y variable (FFR) 

group xdata
for !i=1 to 120
	xdata.add series{!i}
next
xdata.drop series77

' Selection of key variables for impulse response analysis 
'be carefull when you choose index number
' Y=ffr ordered last in the state space form, so its index 120
' remember -- with Y dropped from xdata, so -1 after 77. for exmaple, index(120)=120-1 
vector xir =@fill(120, 16, 107, 77, 80, 95, 92, 74, 101, 17, 49, 50, 51, 26, 48, 117, 54, 62, 71, 119)

'Vector of transformation code of Y (ffr) variable + selection of key variables (xir) 
'1 for no transformation 
'4 for logarithm
'5 for first difference of logarithm

vector code =@fill(1, 5, 5, 1, 1, 5, 5, 5, 1, 1, 5, 5, 5, 1, 1, 5, 4, 1, 1, 1)

'Name of Y variables Y(ffr) + selected key variables (xir)
' Please first put a name of Y variable then selected variables
text yx_name 
yx_name.append(file) yx_name.txt

' or append manually 
' yx_name.append FFR
' yx_name.append IP
' yx_name.append CPI
'......
' yx_name.append Consumer Expectation  

bfavar(factor=3, horizon=48, rep=800, burn=200, ci=0.9) 13 xdata xir code yx_name @ ffr


